/* 
 *           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                    Version 2, December 2004
 *  
 * Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
 * 
 * Everyone is permitted to copy and distribute verbatim or modified
 * copies of this license document, and changing it is allowed as long
 * as the name is changed.
 *  
 *            DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *  
 *  0. You just DO WHAT THE FUCK YOU WANT TO.
 */

/*
 * BPE text encoder
 * author : MooZ
 */ 
#ifndef _BPE_H_
#define _BPE_H_

#include <stdint.h>

enum BPE_RETURN_VALUE
{
	BPE_ALLOCATION_ERROR = -1,
	BPE_ERROR = 0,
	BPE_OK = 1
};

struct BPEPair
{
	uint8_t first;
	uint8_t second;
};

struct BPEData
{
	uint8_t *dictionary;
	int dictionaryLength;
	
	struct BPEPair *pairs;
	int pairCount;
	
	uint8_t *compressedString;
	int compressedStringLength;
};

int8_t bpeInit( struct BPEData* bpe, uint8_t *dictionary, int dictionaryLength );
void bpeClear( struct BPEData* bpe );

int8_t bpeEncode( const char* source, int sourceSize, const uint8_t* ignore, int ignoreLength, struct BPEData* bpe );

#endif /* _BPE_H_ */
